% Example 3.12 (3-11, 3-12 Textbook)
% Response of a low pass RC filter to a periodic rectangular
% odd signal of amplitude A, and period T_0 second
% The input signal is represented by its complex Fourier coefficients
% The program evaluates and plots the input/output signals and
% the their amplitude spectrum.
% H. Saadat  Winter 98-99 

RC = input('Enter the filter time constant RC = '); 
n = input('Enter the highest odd harmonic n = ');
A =1; T_0 = 1;, f_0 = 1/T_0;
t=0:0.001:1;
w_0 = 2*pi*f_0;
x = 0; y=0; 
m =0; H=0; X_n=0; Y_n=0;
for k = -n:2:n
   m=m+1;
   H(m) = 1/(1 + j*w_0*k*RC);            
   X_n(m) = -j*A/(k*pi)*(1 - cos(k*pi)); 
   Y_n(m) = H(m)*X_n(m); 
   x = x + X_n(m)*exp(j*k*w_0*t); 
   y = y + Y_n(m)*exp(j*k*w_0*t);   
end 
nf_0 = [-n:2:n]*f_0;
subplot(3,1,1), plot(t, real(x), 'b',  t, real(y), 'r')
xlabel('t, s')
title(['Low Pass RC Filter,  RC = ', num2str(RC),... 
       's,  Max. Harmonics = ', num2str(n)])
legend('Input signal', 'Output signal')
subplot(3,1,2), stem(nf_0, abs(X_n), 'b')
ylabel('Amplitude'), legend('Input spectrum')
subplot(3,1,3), stem(nf_0, abs(Y_n), 'r') 
xlabel('nf_0, Hz'), ylabel('Amplitude'), legend('Output spectrum')